/*================================================================================

	[Zombie Plague: CSO Characters]
	Copyright (C) 2014. By Nax0ne
	
	~~~~~~~~~~~
	- Licence -
	~~~~~~~~~~~
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	In addition, as a special exception, the author gives permission to
	link the code of this program with the Half-Life Game Engine ("HL
	Engine") and Modified Game Libraries ("MODs") developed by Valve,
	L.L.C ("Valve"). You must obey the GNU General Public License in all
	respects for all of the code used other than the HL Engine and MODs
	from Valve. If you modify this file, you may extend this exception
	to your version of the file, but you are not obligated to do so. If
	you do not wish to do so, delete this exception statement from your
	version.

=================================================================================*/

/*================================================================================
 [Include Files]
=================================================================================*/

#include < amxmodx >
#include < fakemeta >
#include < hamsandwich >
#include < zombieplague >

/*================================================================================
 [Vars, Arrays, CVARS Pointers & Bools]
=================================================================================*/

#define ADDON_NAME "[ZP] CSO Characters"
#define ADDON_VERSION "1.0.0"
#define ADDON_AUTHOR "Nax0ne"

enum (+= 100)
{
    TASK_SELECTMODEL = 2000
} 

new g_player_sex[33];

// Radio sound
#define MAXRADIO 23
new const RADIO_MESSEAGE[MAXRADIO][] = {
	"COVERME",
	"TAKEPOINT",
	"POSITION",
	"REGROUP",
	"FOLLOWME",
	"HITASSIST",
	"GO",
	"FALLBACK",
	"STICKTOG",
	"GETINPOS",
	"STORMFRON",
	"REPORTIN",
	"AFFIRM",
	"ROGER",
	"ENEMYSPOT",
	"BACKUP",
	"CLEAR",
	"INPOS",
	"REPRTINGIN",
	"BLOW",
	"NEGATIVE",
	"ENEMYDOWN",
	"FIREINHOLE"
}
new const RADIO_FILE[MAXRADIO][] = {
	"ct_coverme",
	"takepoint",
	"position",
	"regroup",
	"followme",
	"fireassis",
	"com_go",
	"fallback",
	"sticktog",
	"com_getinpos",
	"stormfront",
	"com_reportin",
	"ct_affirm",
	"roger",
	"ct_enemys",
	"ct_backup",
	"clear",
	"ct_inpos",
	"ct_reportingin",
	"blow",
	"negative",
	"enemydown",
	"ct_fireinhole"
}

new const g_fem_pain_snd[][] = 
{ 
	"player/f_bhit_flesh-1.wav",
	"player/f_bhit_flesh-2.wav",
	"player/f_bhit_flesh-3.wav"
}

new const g_fem_die_snd[][] = 
{ 
	"player/f_die1.wav",
	"player/f_die2.wav",
	"player/f_die3.wav"
}

new const g_player_models[][] = {
	// Female Models
	"cso_chngirl01",
	"cso_choijiyoon",
	"cso_yuri",
	"cso_natasha",
	"cso_jpngirl01",
	"cso_yuri",
	"cso_alice",
	"cso_blair",
	"cso_criss",
	"cso_ritsuka",
	"cso_pirategirl",
	// Male Models
	"cso_davidblack",
	"cso_gerrard",
	"cso_hunter",
	"cso_rbc",
	"cso_spade",
	"cso_vc",
	"cso_ara",
	"cso_marineboy",
	"cso_pirateboy",
	"cso_nlc",
	"cso_fernando"
}

/*================================================================================
 [Plugin Init + Precache + Natives]
=================================================================================*/

public plugin_init()
{
	// Register New Addon
	register_plugin(ADDON_NAME, ADDON_VERSION, ADDON_AUTHOR);
	
	register_message(get_user_msgid("SendAudio"), "message_SendAudio");
	
	register_forward(FM_EmitSound, "fw_emitsound");	
	RegisterHam(Ham_Spawn, "player", "fw_playerspawn", 1);
	
	set_msg_block(get_user_msgid("ClCorpse"), BLOCK_SET );
}

public plugin_precache()
{
	server_cmd("sv_filetransfercompression 0");
	
	precache_sound("zombie_mode/human_death_01.wav"); 
	precache_sound("zombie_mode/human_death_02.wav"); 
	precache_sound("zombie_mode/human_death_female_01.wav"); 
	precache_sound("zombie_mode/human_death_female_02.wav"); 	
	
	new i, szModelPath[64];
	
	for(i = 0; i < sizeof g_fem_pain_snd; i++) engfunc(EngFunc_PrecacheSound, g_fem_pain_snd[i]);
	for(i = 0; i < sizeof g_fem_die_snd; i++) engfunc(EngFunc_PrecacheSound, g_fem_die_snd[i]);

	for(i = 0; i < sizeof g_player_models; i++)
	{
		formatex(szModelPath, sizeof(szModelPath) - 1, "models/player/%s/%s.mdl", g_player_models[i], g_player_models[i])
		engfunc(EngFunc_PrecacheModel, szModelPath);
	}		
}

public plugin_natives()
{
	register_native("zb_radio_send_all", "natives_radio_send_all", 1);
}

/*================================================================================
 [Main Events & Forwards]
=================================================================================*/

public client_disconnect(id)
{
	g_player_sex[id] = 0
	
	new szName[32];
	get_user_name(id, szName, 31);
		
	client_print(0, print_chat, "%s has left the game", szName);	
}  

public client_putinserver(id)
{	
	g_player_sex[id] = 0
	
	new szName[32];
	get_user_name(id, szName, 31);
		
	client_print(0, print_chat, "%s connected", szName);
}

public message_SendAudio(msg_id, msg_dest, msg_entity) // By CSO-NST 
{
	// get value
	new audio[64], audio_f[64], id, sex
	
	id = get_msg_arg_int(1)	
	sex = g_player_sex[id]
	get_msg_arg_string(2, audio, charsmax(audio))
	format(audio_f, charsmax(audio_f), "%s", audio)
	
	// replace sound radio 1 - 3
	new check, radio_new[64]
	for (new i=0; i<23; i++)
	{
		if( equal(audio[7], RADIO_MESSEAGE[i]))
		{
			format(radio_new, charsmax(radio_new), "%s", get_urlsound_radio(RADIO_FILE[i], sex))
			check = 1
		}
	}
	
	// replace sound radio other
	if (!check && !equal(audio_f, "%!MRAD_ctwin") && !equal(audio_f, "%!MRAD_terwin") && !equal(audio_f, "%!MRAD_rounddraw"))
	{
		// radio one
		replace(audio, charsmax(audio), "%!MRAD_", "")
		strtolower(audio)
		format(radio_new, charsmax(radio_new), "%s", get_urlsound_radio(audio, sex))
		send_radio_all(audio)
		return PLUGIN_HANDLED;
	}
	
	if(equal(audio_f, "%!MRAD_ctwin") || equal(audio_f, "%!MRAD_terwin") || equal(audio_f, "%!MRAD_rounddraw"))
	{
		return PLUGIN_HANDLED;
	}
	
	// replace radio
	if (file_exists(get_fullurl_radio(radio_new))) set_msg_arg_string(2, radio_new)
	
	return PLUGIN_CONTINUE;
}

public zp_user_infected_post(id, infector, nemesis)
{
	if(is_user_alive(infector))
	{
		if(g_player_sex[id] == 1)
		{
			g_player_sex[id] = 3
			
			switch(random_num(1, 2))
			{
				case 1:
				{
					emit_sound(id, CHAN_VOICE, "zombie_mode/human_death_01.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
				}
				case 2:
				{
					emit_sound(id, CHAN_VOICE, "zombie_mode/human_death_02.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
				}
			}
		}
		
		if(g_player_sex[id] == 2)
		{
			g_player_sex[id] = 3
			
			switch(random_num(1, 2))
			{
				case 1:
				{
					emit_sound(id, CHAN_VOICE, "zombie_mode/human_death_female_01.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
				}
				case 2:
				{
					emit_sound(id, CHAN_VOICE, "zombie_mode/human_death_female_02.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
				}
			}
		}		
	}
}  

public fw_playerspawn(id)
{		
	if(!is_user_alive(id))
		return HAM_IGNORED;
	
	if(!zp_get_user_zombie(id))
	{
		if(random_num(1, 2) == 1)
		{
			set_task(0.1, "task_selectmodel", TASK_SELECTMODEL + id);
			g_player_sex[id] = 1
		}
		else
		{
			set_task(0.1, "task_selectmodel", TASK_SELECTMODEL + id);
			g_player_sex[id] = 2
		}
	}

	return HAM_IGNORED;
}

public fw_emitsound(id, channel, const sample[128], Float:volume, Float:attn, flags, pitch)
{
	if (!is_user_connected(id) || zp_get_user_zombie(id) || zp_get_user_nemesis(id) || zp_get_user_survivor(id) || g_player_sex[id] == 1 || g_player_sex[id] == 3)
		return FMRES_IGNORED;
		
	if((sample[7] == 'b' && sample[8] == 'h' && sample[9] == 'i' && sample[10] == 't') || (sample[7] == 'h' && sample[8] == 'e' && sample[9] == 'a' && sample[10] == 'd')) 
	{
		emit_sound(id, channel, g_fem_pain_snd[random(sizeof(g_fem_pain_snd))], volume, attn, flags, pitch)
		return FMRES_SUPERCEDE;
	}
	
	if(sample[7] == 'd' && ((sample[8] == 'i' && sample[9] == 'e') || (sample[8] == 'e' && sample[9] == 'a')) && g_player_sex[id] == 2)
	{
		
		emit_sound(id, channel, g_fem_die_snd[random(sizeof(g_fem_die_snd))], volume, attn, flags, pitch)
		return FMRES_SUPERCEDE;   
	}  	
	
	return FMRES_IGNORED;
}

/*================================================================================
 [Tasks]
=================================================================================*/

public task_selectmodel(taskid)
{
	static id
	id = taskid - TASK_SELECTMODEL
	
	if(is_user_alive(id) && !zp_get_user_zombie(id))
	{
		if(g_player_sex[id] == 1)
		{
			switch(random_num(1, 11))
			{
				case 1:
				{
					zp_override_user_model(id, "cso_davidblack")
				}
				case 2:
				{
					zp_override_user_model(id, "cso_gerrard")
				}
				case 3:
				{
					zp_override_user_model(id, "cso_hunter")
				}
				case 4:
				{
					zp_override_user_model(id, "cso_rbc")
				}
				case 5:
				{
					zp_override_user_model(id, "cso_spade")
				}
				case 6:
				{
					zp_override_user_model(id, "cso_vc")
				}
				case 7:
				{
					zp_override_user_model(id, "cso_ara")
				}
				case 8:
				{
					zp_override_user_model(id, "cso_marineboy")
				}
				case 9:
				{
					zp_override_user_model(id, "cso_pirateboy")
				}
				case 10:
				{
					zp_override_user_model(id, "cso_nlc")
				}
				case 11:
				{
					zp_override_user_model(id, "cso_fernando")
				}				
			}
		}
		
		if(g_player_sex[id] == 2)
		{
			switch(random_num(1, 10))
			{
				case 1:
				{
					zp_override_user_model(id, "cso_chngirl01")
				}
				case 2:
				{
					zp_override_user_model(id, "cso_choijiyoon")
				}
				case 3:
				{
					zp_override_user_model(id, "cso_natasha")
				}
				case 4:
				{
					zp_override_user_model(id, "cso_yuri")
				}
				case 5:
				{
					zp_override_user_model(id, "cso_jpngirl01")
				}
				case 6:
				{
					zp_override_user_model(id, "cso_alice")
				}
				case 7:
				{
					zp_override_user_model(id, "cso_blair")
				}
				case 8:
				{
					zp_override_user_model(id, "cso_criss")
				}
				case 9:
				{
					zp_override_user_model(id, "cso_ritsuka")
				}
				case 10:
				{
					zp_override_user_model(id, "cso_pirategirl")
				}				
			}
		}
	}
}

/*================================================================================
 [Internal Functions]
=================================================================================*/ 

get_urlsound_radio(filename[], sex)
{
	new audio[64];
	
	if(sex == 1)
	{
		format(audio, charsmax(audio), "radio/%s.wav", filename)
	}
	else if(sex == 2)
	{
		format(audio, charsmax(audio), "radio/woman/%s.wav", filename)
	}
	else if(sex == 3)
	{
		format(audio, charsmax(audio), "radio/zombi/%s.wav", filename)
	}
	
	return audio;
}

get_fullurl_radio(file[])
{
	new audio[64];
	format(audio, charsmax(audio), "sound/%s", file)
	
	return audio;
}

send_radio_all(audio[])
{
	for(new id = 1; id <= get_maxplayers(); id++)
	{
		if (!is_user_connected(id)) continue;
		
		message_begin(MSG_ONE, get_user_msgid("SendAudio"), _, id)
		write_byte(0)
		write_string(get_urlsound_radio(audio, g_player_sex[id]))
		write_short(100)
		message_end()
	}
}

/*================================================================================
 [Natives]
=================================================================================*/ 

public natives_radio_send_all(const audio[])
{
	param_convert(1)
	new filename[64];
	format(filename, charsmax(filename), "%s", audio)
	send_radio_all(filename)
	return 0;
}
